/*
  BeNoPPP
  About View
  (c) 2003 - Sylvain Tertois
*/

#include "AboutView.h"
#include <TextView.h>
#include <ScrollView.h>
#include <Font.h>

// constructor
AboutView::AboutView(BRect r)
	: BView(r,NULL,B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	m_Created=false;
}

// destructor
AboutView::~AboutView()
{
}

// called when tab is activated
void AboutView::AttachedToWindow()
{
	// are the child views already created?
	if (!m_Created)
	{
		// no. do it
		
		// change the view backgorund color
		SetViewColor(ui_color(B_MENU_BACKGROUND_COLOR));
		
		// create a rectangle for the text view
		BRect l_ViewRect=Bounds();
		l_ViewRect.InsetBy(5,5);
		l_ViewRect.right -= B_V_SCROLL_BAR_WIDTH;	// remove the vertical scroll bar width
		BRect l_TextRect(l_ViewRect);
		l_TextRect.OffsetTo(0,0);
		l_TextRect.InsetBy(2,2);			// create a smaller rectangle for the text itself
		
		// create the text view
		BTextView *l_TextView = new BTextView(l_ViewRect,NULL,l_TextRect,
			B_FOLLOW_ALL_SIDES,B_WILL_DRAW);
		// and the scroll view that holds it
		AddChild(new BScrollView(NULL,l_TextView,B_FOLLOW_ALL,0,false,true));
		
		// adjust a few parameters
		l_TextView->MakeEditable(false);
		l_TextView->SetAlignment(B_ALIGN_CENTER);
		l_TextView->SetText("BeNoPPP\nBe No Parts Pic Programer\n"
			"© 2004 Sylvain Tertois\nversion 1.01\n"
			"This is a complete re-write of NoPPP 0.3 for BeOS\n"
			"Original NoPPP by Michael A. Covington\n"
			"Linux port by Claus Fuetterer\n"
			"PIC read & 16F87x enhancements by Geoff McCaughan\n");
		
		// change the font and color of 'BeNoPPP'
		l_TextView->SetStylable(true);
		BFont l_Font(be_bold_font);
		l_Font.SetSize(24);
		/// blue 'B'
		const rgb_color l_ColorBlue={0,0,192,0};
		l_TextView->SetFontAndColor(0,1,&l_Font,B_FONT_ALL, &l_ColorBlue);
		///	red 'e'
		const rgb_color l_ColorRed={192,0,0,0};
		l_TextView->SetFontAndColor(1,2,&l_Font,B_FONT_ALL, &l_ColorRed);
		/// green 'NoPPP'
		const rgb_color l_ColorGreen={0,96,0,0};
		l_TextView->SetFontAndColor(2,7,&l_Font,B_FONT_ALL, &l_ColorGreen);
		
		// the view is now constructed
		m_Created=true;
	}
}
