/*
  BeNoPPP
  Erase Thread
  (c) 2003 - Sylvain Tertois
*/

#ifndef ERASETHREAD_H
#define ERASETHREAD_H

#include <Looper.h>
#include "NoPPPDriver.h"

class BMessenger;

// thread that reads the PIC contents
class EraseThread : public BLooper
{
public:
	EraseThread(BMessenger *eraseview, unsigned int iobase, UsePin *pins, bool detect);
	~EraseThread();
	
	// hook functions
	virtual void MessageReceived(BMessage *);
	
private:
	// execute the operation
	void Go();
	
	// one programing cycle (word write)
	void ProgCycle(NoPPPDriver *driver, PicCommand command, unsigned int data);
	
	// parameters
	BMessenger *m_EraseView;		// messenger to the view
	unsigned int m_IOBase;				// IO base address
	UsePin *m_Pins;						// hardware configuration
	bool m_DetectHardware;			// Do we detect the hardware before working?

	typedef enum _messages {
		ET_GO='EtGo'					// Go
	} Messages;
};

#endif //ERASETHREAD_H
