/*
  BeNoPPP
  Erase View
  (c) 2003 - Sylvain Tertois
*/

#include "EraseView.h"
#include "MainWindow.h"
#include "PicList.h"
#include "EraseThread.h"
#include "Preferences.h"
#include <Button.h>	
#include <TextView.h>

// constructor
EraseView::EraseView(BRect r, MainWindow *win)
	: BView(r,NULL,B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	m_MainWindow = win;
	m_Created=false;
}

// destructor
EraseView::~EraseView()
{
}

static const float c_XMargin=5;
static const float c_YMargin=5;

// hook function called when the tab is activated
void EraseView::AttachedToWindow()
{
	if (!m_Created)
	{
		// first call, we must add the child views
		// get the correct color
		SetViewColor(ui_color(B_MENU_BACKGROUND_COLOR));
		

		// message
		float l_X,l_Y;
		l_X=Bounds().right-c_XMargin;
		l_Y=c_YMargin;
		BTextView *l_TextView = new BTextView(BRect(c_XMargin,l_Y,l_X,l_Y+40),
			NULL,BRect(0,0,l_X-c_XMargin,40),B_FOLLOW_ALL_SIDES);
		l_TextView->SetText("Warning: do not insert the PIC in the programer before "
			"clicking on the button below!\n"
			"Insert it only when told to do so.");
		AddChild(l_TextView);
		l_TextView->SetViewColor(ui_color(B_MENU_BACKGROUND_COLOR));
		l_TextView->ResizeToPreferred();
		l_TextView->MakeEditable(false);
		l_TextView->MakeSelectable(false);
		l_Y=l_TextView->Frame().bottom+3*c_YMargin;

		// the 'Start' button		
		m_Start = new BButton(BRect(c_XMargin,l_Y,c_XMargin,l_Y),NULL,"Start",
			new BMessage(EV_START));
		AddChild(m_Start);
		m_Start->SetTarget(this);
		m_Start->ResizeToPreferred();
		l_Y=m_Start->Frame().bottom+c_YMargin;
					
		m_Created=true;
	}
}

// hook function called when a message arrives
void EraseView::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case EV_START:
			// the user clicked on 'start'
			// start a new thread that will do the work
			new EraseThread(new BMessenger(this),g_Preferences->m_IOBase,
				g_Preferences->m_PinsConfig->m_Pins,
				g_Preferences->m_DetectHardware);
			break;
		
		case EV_ERASESTARTED:
			// the work just started. Vpp isn't on yet
			m_MainWindow->DisplayVppOff();
			break;
		
		case EV_VPPON:
			// vpp is now on
			m_MainWindow->DisplayVppOn();
			break;
		
		case EV_ERASESTOPPED:
			// the work is finished
			m_MainWindow->DisplayVppOff();
			break;
		
		default:
			BView::MessageReceived(message);
	}
}
	
