/*
  BeNoPPP
  EraseView
  (c) 2003 - Sylvain Tertois
*/

#ifndef ERASEVIEW_H
#define ERASEVIEW_H

#include <View.h>

class MainWindow;
class BButton;

// read view: erase the PIC
class EraseView : public BView
{
public:
	EraseView(BRect r, MainWindow *win);
	~EraseView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
private:
	// pointer to window
	MainWindow *m_MainWindow;
	
	// pointers to controls
	BButton *m_Start;
	
	// false when the object is constructed, true once the child views have been added
	bool m_Created;
	
public:
	// view messages
	typedef enum _messages {
		EV_START='EvSt',				// start the erasing (user clicked on 'start')
		EV_ERASESTARTED,			// sent by the EraseThread when the erasing starts
		EV_VPPON,						// sent by the EraseThread when VPP is put on
		EV_ERASESTOPPED				// sent by the EraseThread when the erasing ends
		} Messages;
};

#endif //ERASEVIEW_H
