/*
  BeNoPPP
  Main Window
  (c) 2003 - Sylvain Tertois
*/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <Window.h>

#include "PinsConfig.h"

class BStringView;
class BMenuField;

class PinsView;

// main window; the one that contains all the tabs
class MainWindow : public BWindow
{
public:
	MainWindow();
	~MainWindow();
	
	// hook functions
	virtual void MessageReceived(BMessage*);
	virtual bool QuitRequested();
	
	// change the vpp display
	void DisplayVppOn();		// display "vpp on" in red
	void DisplayVppOff();		// display "vpp off" in green
	
	// unused yet... should lock the tabs while the programer is working
	void LockControls();
	void UnlockControls();
	
	// add/remove a configuration to/from the 'hardware' menu
	void AddHardwareConfig(PinsConfig*);
	void RemoveHardwareConfig(const char *name);
	
	// recreate the port menu when the hardware is changed
	void RecreatePortMenu(PortType);
		
	// tells if a configuration with this name exists
	bool ConfigExists(const char *name);
	
	// select a configuration
	void SelectConfig(int num);
	void SelectConfig(const char *name);
	void SelectConfig(BMenuItem *item);
	
private:

	// pointers to views and controls
	BMenuField *m_PortField;
	BMenuField *m_HardwareField;
	BStringView *m_VppStatus;
	
	PinsView *m_PinsView;

public:
	// window messages
	typedef enum _messages {
		BNPPP_CHANGEBASE='BnPp',	// the user changed the IO base
		BNPPP_CHANGEHARD			// the user changed the hardware type
	} Messages;
};

#endif //MAINWINDOW_H
