/*
  BeNoPPP
  "New Pins Configuration" Window
  (c) 2003 - Sylvain Tertois
*/

#ifndef NEWPINCONFIGWIN_H
#define NEWPINCONFIGWIN_H

#include <Window.h>

#include "PinsConfig.h"

class BMenuField;
class BTextControl;
class BButton;

class MainWindow;

// main window; the one that contains all the tabs
class NewPinConfigWin : public BWindow
{
public:
	NewPinConfigWin(MainWindow *);
	~NewPinConfigWin();
	
	// hook functions
	virtual void MessageReceived(BMessage*);
				
private:

	// pointers to views and controls
	BTextControl *m_Name;
	BMenuField *m_CopyFromField;
	BButton *m_OK;
	
	MainWindow *m_MainWin;
	
	// parameters
	PortType m_Type;
	PinsConfig *m_CopyFrom;
	
	// private methods
	void ChangeCopyFromField(PortType newType);
	
public:
	// window messages
	typedef enum _messages {
		NPCW_CHANGEPORTTYPE='ChPt',	// the user changed the port type
		NPCW_CHANGENAME,					// the user changed the name
		NPCW_OK,								// the user clicked on OK
		NPCW_CHANGECPFROM,				// the user changed the 'copy from' field
	} Messages;
};

#endif //NEWPINCONFIGWIN_H
