/*
  BeNoPPP
  Pins configuration
  (c) 2003 - Sylvain Tertois
*/

#ifndef PINSCONFIG_H
#define PINSCONFIG_H

#include <Archivable.h>
#include <String.h>

typedef struct _usepin UsePin;
typedef enum _porttype { PARALLEL=0, SERIAL, NUMTYPES } PortType;

class PinsConfig : public BArchivable
{
public:
	PinsConfig();
	PinsConfig(BMessage *archive);
	PinsConfig(const PinsConfig *source);
	~PinsConfig();
	
	// BArchivable functions
	static BArchivable *Instantiate(BMessage *archive);
	virtual status_t Archive(BMessage *archive, bool deep=true) const;
	
	// contents
	BString m_Name;
	PortType m_PortType;
	bool m_IsSystem;	// true: is system configuration (read-only) false: is user configuration
	UsePin *m_Pins;
};

#endif //PINSCONFIG_H
