/*
  BeNoPPP
  Pins View
  (c) 2003 - Sylvain Tertois
*/

#ifndef PINSVIEW_H
#define PINSVIEW_H

#include <View.h>
#include "ControlCodes.h"

class BButton;
class MainWindow;
class BMenuField;
class BCheckBox;

// pins view: lets the user change the pins configuration
class PinsView : public BView
{
public:
	PinsView(BRect r, MainWindow *mainwin);
	~PinsView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
	// called when the selected configuration changes
	void PinsConfigChanged();
	
private:
	// false when object is constructed, true once the child views have been added
	bool m_Created;	
	
	// controls
	BButton *m_DeleteButton;
	BMenuField *m_PinsFields[NUMFUNCTIONS];
	BCheckBox *m_PinsInv[NUMFUNCTIONS];
	
	MainWindow *m_MainWin;

public:
	// view messages
	typedef enum _messages {
		PV_CREATECONFIG='CrCo',	// the user wants to create a new configuration
		PV_DELETECONFIG,				// the user wants to delete the configuration
		PV_SAVERSC,					// save the configuration as a resource file (developper version only)
		PV_CHANGEPIN,					// a pin has been changed
		PV_CHANGEINV					// an 'inv' checkbox has been activated
		} Messages;

private:
	// private functions
	BMenuItem *AddMenuEntry(Function function, Pin pin);
	void SaveResource();
};

#endif //PINSVIEW_H
