/*
  BeNoPPP
  Preferences class
  (c) 2003 - Sylvain Tertois
*/

#ifndef PREFERENCES_H
#define PREFERENCES_H

#include <Archivable.h>
#include <String.h>
#include <Rect.h>
#include <List.h>
#include "MemoryBlock.h"

class PinsConfig;
class Preferences : public BArchivable
{
public:
	Preferences();
	Preferences(BMessage *archive);
	~Preferences();
	
	// BArchivable functions
	static BArchivable *Instantiate(BMessage *archive);
	virtual status_t Archive(BMessage *archive, bool deep=true) const;

	// preferences values
	BRect m_MainWindowRect;			// position and size of window
	unsigned int m_IOBase;				// IO base address
	bool m_DetectHardware;			// detect hardware or not?
	BString m_HexPath;					// default hex file path for the panels
	HexFormat m_HexFormat;			// default hex format
	bool m_VerifyWhenWrite;			// verify when write into PIC or not?
	unsigned int m_PicTypeNum;		// default PIC type number
	PinsConfig *m_PinsConfig;			// selected pins configuration
	
	// pin configurations
	BList m_SystemPinConfigs;
	BList m_UserPinConfigs;

private:
	void LoadSystemConfigs(const char *nametoselect);			
			// load system pin configurations from resources
};

// global Preferences instantiation
extern Preferences *g_Preferences;

#endif //PREFERENCES_H
