/*
  BeNoPPP
  PrefsView
  (c) 2003 - Sylvain Tertois
*/

#include "PrefsView.h"
#include "MainWindow.h"
#include "Preferences.h"
#include <CheckBox.h>	

// constructor
PrefsView::PrefsView(BRect r, MainWindow *win)
	: BView(r,NULL,B_FOLLOW_ALL_SIDES,B_WILL_DRAW)
{
	m_MainWindow = win;
	m_Created=false;
}

// destructor
PrefsView::~PrefsView()
{
}

static const float c_XMargin=5;
static const float c_YMargin=5;

// hook function called when the tab is activated
void PrefsView::AttachedToWindow()
{
	if (!m_Created)
	{
		// first call, we must add the child views
		// get the correct color
		SetViewColor(ui_color(B_MENU_BACKGROUND_COLOR));
		

		// detect checkbox
		float l_X,l_Y;
		l_X=Bounds().left+c_XMargin;
		l_Y=c_YMargin;
		m_DetectProg=new BCheckBox(BRect(l_X,l_Y,l_X,l_Y),NULL,
			"detect Pic programer",new BMessage(PV_DETECTCHANGED));
		AddChild(m_DetectProg);
		m_DetectProg->ResizeToPreferred();
		m_DetectProg->SetTarget(this);
		l_Y=m_DetectProg->Frame().bottom+c_YMargin;
					
		m_Created=true;
	}
	
	// this part of the function is executed each time the tab is activated. We update the controls in case they have been modified elsewhere
	// update the value of the detect checkbox
	m_DetectProg->SetValue(g_Preferences->m_DetectHardware?1:0);
}

// hook function called when a message arrives
void PrefsView::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case PV_DETECTCHANGED:
			// the user changed the detect mode
			// save the new mode in the preferences
			g_Preferences->m_DetectHardware=(m_DetectProg->Value()!=0);
			break;
				
		default:
			BView::MessageReceived(message);
	}
}
	
