/*
  BeNoPPP
  Read Thread
  (c) 2003 - Sylvain Tertois
*/

#ifndef READTHREAD_H
#define READTHREAD_H

#include <Looper.h>
#include "MemoryBlock.h"
#include "NoPPPDriver.h"


class BMessenger;

// thread that reads the PIC contents
class ReadThread : public BLooper
{
public:
	ReadThread(BMessenger *readview, unsigned int picType, HexFormat fileFormat, const char *fileName, unsigned int iobase, UsePin *pins, bool detect);
	~ReadThread();
	
	// hook functions
	virtual void MessageReceived(BMessage *);
	
private:
	// execute the operation
	void Go();
	
	// called by Go() tu update the status bar
	void Update(const char *text=NULL);
	
	// parameters
	BMessenger *m_ReadView;		// messenger to the view
	unsigned int m_PicType;				// PIC type
	HexFormat m_FileFormat;			// Hex file format
	const char *m_FileName;			// file name
	unsigned int m_IOBase;				// OI base address
	UsePin *m_Pins;						// hardware configuration
	bool m_DetectHardware;			// Do we detect the hardware before working?
	
	// thread messages
	typedef enum _messages {
		RT_GO='RtGo'					// Go
	} Messages;
};

#endif //READTHREAD_H
