/*
  BeNoPPP
  Read View
  (c) 2003 - Sylvain Tertois
*/

#ifndef READVIEW_H
#define READVIEW_H

#include <View.h>

class MainWindow;
class BButton;
class BTextControl;
class BFilePanel;
class BMenuField;
class BStatusBar;

#include "MemoryBlock.h"

// read view: read the PIC and write its contents in a file
class ReadView : public BView
{
public:
	ReadView(BRect r, MainWindow *win);
	~ReadView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
private:
	// pointer to window
	MainWindow *m_MainWindow;
	
	// pointers to controls
	BButton *m_Start,*m_FileButton;
	BTextControl *m_FileName;
	BMenuField *m_PicTypeField, *m_FileFormatField;

	// file panel to save the hex contents
	BFilePanel *m_Panel;
	
	// status bar: show the read progression
	BStatusBar *m_StatusBar;
	
	// false when the object is constructed, true once the child views have been added
	bool m_Created;
	
public:
	// view messages
	typedef enum _messages {
		RV_FILEPANEL='RvFp',			// open the file panel
		RV_FILENAMECHANGED,		// the user changed the file name
		RV_PICTYPECHANGED,			// the user changed the PIC type
		RV_FORMATCHANGED,		// the user changed the file format
		RV_START,						// start the reading (user clicked on 'start')
		RV_READSTARTED,				// sent by the ReadThread when the reading starts
		RV_VPPON,						// sent by the ReadThread when VPP is put on
		RV_READSTOPPED,				// sent by the ReadThread when the reading ends
		RV_STATUSMAX,				// sent by the ReadThread to say how many RV_STATUSUPDATE message it will send
		RV_STATUSUPDATE 			// sent by the ReadThread to update the status bar
		} Messages;
};

#endif //READVIEW_H
