/*
  BeNoPPP
  Test View
  (c) 2003 - Sylvain Tertois
*/

#ifndef TESTVIEW_H
#define TESTVIEW_H

#include <View.h>

class MainWindow;
class BButton;
class NoPPPDriver;
class BTextView;

// test view: let the user test his programer
class TestView : public BView
{
public:
	TestView(BRect r, MainWindow *win);
	~TestView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
private:
	// pointer to window
	MainWindow *m_MainWindow;
	
	// pointer to controls
	BButton *m_StartButton,*m_StopButton,*m_NextButton;
	
	// pointer to the view that displays the test text
	BTextView *m_TextView;
	
	// holds the current test number
	unsigned int m_StageNumber;
	
	// pointer to the driver
	NoPPPDriver *m_Driver;
	
	// false when object is constructed, true once the child views have been added
	bool m_Created;
	
public:
	// view messages
	typedef enum _messages {
		TV_START='TvSt',			// start the test
		TV_STOP,						// stop the test
		TV_NEXT 						// proceed to next test
		} Messages;		
};

#endif //TESTVIEW_H
