/*
  BeNoPPP
  Write Thread
  (c) 2003 - Sylvain Tertois
*/

#ifndef VERIFYTHREAD_H
#define VERIFYTHREAD_H

#include <Looper.h>
#include "NoPPPDriver.h"

class BMessenger;

// thread that verifies the PIC contents
class VerifyThread : public BLooper
{
public:
	VerifyThread(BMessenger *verifyview, unsigned int picType, const char *fileName, unsigned int iobase, UsePin *pins, bool detect);
	~VerifyThread();
	
	// hook functions
	virtual void MessageReceived(BMessage *);
	
private:
	// execute the operation
	void Go();
	
	// called by Go() tu update the status bar
	void Update(const char *text=NULL);
	
	// parameters
	BMessenger *m_VerifyView;		// messenger to the view
	unsigned int m_PicType;				// PIC type
	const char *m_FileName;			// file name
	unsigned int m_IOBase;				// OI base address
	UsePin *m_Pins;						// hardware configuration
	bool m_DetectHardware;			// Do we detect the hardware before working?
	
	typedef enum _messages {
		VT_GO='WtGo'					// Go
	} Messages;
};

#endif //VERIFYTHREAD_H
