/*
  BeNoPPP
  VerifyView
  (c) 2003 - Sylvain Tertois
*/

#ifndef VERIFYVIEW_H
#define VERIFYVIEW_H

#include <View.h>

class MainWindow;
class BButton;
class BTextControl;
class BFilePanel;
class BMenuField;
class BStatusBar;
class BCheckBox;

// verify view: checks that the PIC contents are indentical to a hex file
class VerifyView : public BView
{
public:
	VerifyView(BRect r, MainWindow *win);
	~VerifyView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
private:
	// pointer to window
	MainWindow *m_MainWindow;
	
	// pointers to controls
	BButton *m_Start,*m_FileButton;
	BTextControl *m_FileName;
	BMenuField *m_PicTypeField;

	// file panel to save the hex contents
	BFilePanel *m_Panel;
	
	// status bar: show the read progression
	BStatusBar *m_StatusBar;
	
	// false when the object is constructed, true once the child views have been added
	bool m_Created;
	
public:
	// view messages
	typedef enum _messages {
		VV_FILEPANEL='VvFp',			// open the file panel
		VV_FILENAMECHANGED,		// the user changed the file name
		VV_PICTYPECHANGED,			// the user changed the PIC type
		VV_START,						// start the verifying (user clicked on 'start')
		VV_VERIFYSTARTED,			// sent by the VerifyThread when the verifying starts
		VV_VPPON,						// sent by the VerifyThread when VPP is put on
		VV_VERIFYSTOPPED,			// sent by the VerifyThread when the verifying ends
		VV_STATUSMAX,				// sent by the VerifyThread to say how many VV_STATUSUPDATE message it will send
		VV_STATUSUPDATE 			// sent by the VerifyThread to update the status bar
		} Messages;
};

#endif //VERIFYVIEW_H
