/*
  BeNoPPP
  Write Thread
  (c) 2003 - Sylvain Tertois
*/

#ifndef WRITETHREAD_H
#define WRITETHREAD_H

#include <Looper.h>
#include "NoPPPDriver.h"
#include "ControlCodes.h"

class BMessenger;

// thread that writes into the PIC
class WriteThread : public BLooper
{
public:
	WriteThread(BMessenger *writeview, unsigned int picType, const char *fileName, bool verify, unsigned int iobase, UsePin *pins, bool detect);
	~WriteThread();
	
	// hook functions
	virtual void MessageReceived(BMessage *);
	
private:
	// execute the operation
	void Go();
	
	// called by Go() tu update the status bar
	void Update(const char *text=NULL);
	
	// one programing cycle (writing of one word)
	void ProgCycle(NoPPPDriver *driver, PicCommand command, unsigned int data);
	
	// parameters
	BMessenger *m_WriteView;		// messenger to the view
	unsigned int m_PicType;				// PIC type
	const char *m_FileName;			// file name
	bool m_Verify;						// Do we verify each write?
	unsigned int m_IOBase;				// OI base address
	UsePin *m_Pins;						// hardware configuration
	bool m_DetectHardware;			// Do we detect the hardware before working?
	
	typedef enum _messages {
		WT_GO='WtGo'					// Go
	} Messages;
};

#endif //WRITETHREAD_H
