/*
  BeNoPPP
  WriteView
  (c) 2003 - Sylvain Tertois
*/

#ifndef WRITEVIEW_H
#define WRITEVIEW_H

#include <View.h>

class MainWindow;
class BButton;
class BTextControl;
class BFilePanel;
class BMenuField;
class BStatusBar;
class BCheckBox;

// write view: read an hex file and write its content in the PIC
class WriteView : public BView
{
public:
	WriteView(BRect r, MainWindow *win);
	~WriteView();
	
	// hook functions
	virtual void AttachedToWindow();
	virtual void MessageReceived(BMessage *);
	
private:
	// pointer to window
	MainWindow *m_MainWindow;
	
	// pointers to controls
	BButton *m_Start,*m_FileButton;
	BTextControl *m_FileName;
	BMenuField *m_PicTypeField;
	BCheckBox *m_VerifyBox;

	// file panel to read the hex contents
	BFilePanel *m_Panel;
	
	// status bar: show the write progression
	BStatusBar *m_StatusBar;
	
	// false when the object is constructed, true once the child views have been added
	bool m_Created;
	
public:
	// view messages
	typedef enum _messages {
		WV_FILEPANEL='WvFp',		// open the file panel
		WV_FILENAMECHANGED,		// the user changed the file name
		WV_PICTYPECHANGED,		// the user changed the PIC type
		WV_VERIFYCHANGED,			// the user changed the state of the 'verify' check box
		WV_START,						// start the writing (user clicked on 'start')
		WV_WRITESTARTED,			// sent by the WriteThread when the writing starts
		WV_VPPON,						// sent by the WriteThread when VPP is put on
		WV_WRITESTOPPED,			// sent by the WriteThread when the writing ends
		WV_STATUSMAX,				// sent by the WriteThread to say how many WV_STATUSUPDATE message it will send
		WV_STATUSUPDATE 			// sent by the WriteThread to update the status bar
		} Messages;
};

#endif //WRITEVIEW_H
